const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Analytics_eventsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const analytics_events = await db.analytics_events.create(
      {
        id: data.id || undefined,

        event_type: data.event_type || null,
        referrer: data.referrer || null,
        user_agent: data.user_agent || null,
        ip_hash: data.ip_hash || null,
        occurred_at: data.occurred_at || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await analytics_events.setProfile_page(data.profile_page || null, {
      transaction,
    });

    await analytics_events.setLink(data.link || null, {
      transaction,
    });

    await analytics_events.setOrganizations(data.organizations || null, {
      transaction,
    });

    return analytics_events;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const analytics_eventsData = data.map((item, index) => ({
      id: item.id || undefined,

      event_type: item.event_type || null,
      referrer: item.referrer || null,
      user_agent: item.user_agent || null,
      ip_hash: item.ip_hash || null,
      occurred_at: item.occurred_at || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const analytics_events = await db.analytics_events.bulkCreate(
      analytics_eventsData,
      { transaction },
    );

    // For each item created, replace relation files

    return analytics_events;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const analytics_events = await db.analytics_events.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.event_type !== undefined)
      updatePayload.event_type = data.event_type;

    if (data.referrer !== undefined) updatePayload.referrer = data.referrer;

    if (data.user_agent !== undefined)
      updatePayload.user_agent = data.user_agent;

    if (data.ip_hash !== undefined) updatePayload.ip_hash = data.ip_hash;

    if (data.occurred_at !== undefined)
      updatePayload.occurred_at = data.occurred_at;

    updatePayload.updatedById = currentUser.id;

    await analytics_events.update(updatePayload, { transaction });

    if (data.profile_page !== undefined) {
      await analytics_events.setProfile_page(
        data.profile_page,

        { transaction },
      );
    }

    if (data.link !== undefined) {
      await analytics_events.setLink(
        data.link,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await analytics_events.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return analytics_events;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const analytics_events = await db.analytics_events.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of analytics_events) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of analytics_events) {
        await record.destroy({ transaction });
      }
    });

    return analytics_events;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const analytics_events = await db.analytics_events.findByPk(id, options);

    await analytics_events.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await analytics_events.destroy({
      transaction,
    });

    return analytics_events;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const analytics_events = await db.analytics_events.findOne(
      { where },
      { transaction },
    );

    if (!analytics_events) {
      return analytics_events;
    }

    const output = analytics_events.get({ plain: true });

    output.profile_page = await analytics_events.getProfile_page({
      transaction,
    });

    output.link = await analytics_events.getLink({
      transaction,
    });

    output.organizations = await analytics_events.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.profile_pages,
        as: 'profile_page',

        where: filter.profile_page
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.profile_page
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  title: {
                    [Op.or]: filter.profile_page
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.button_links,
        as: 'link',

        where: filter.link
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.link
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  label: {
                    [Op.or]: filter.link
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.referrer) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'analytics_events',
            'referrer',
            filter.referrer,
          ),
        };
      }

      if (filter.user_agent) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'analytics_events',
            'user_agent',
            filter.user_agent,
          ),
        };
      }

      if (filter.ip_hash) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('analytics_events', 'ip_hash', filter.ip_hash),
        };
      }

      if (filter.occurred_atRange) {
        const [start, end] = filter.occurred_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            occurred_at: {
              ...where.occurred_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            occurred_at: {
              ...where.occurred_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.event_type) {
        where = {
          ...where,
          event_type: filter.event_type,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.analytics_events.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('analytics_events', 'event_type', query),
        ],
      };
    }

    const records = await db.analytics_events.findAll({
      attributes: ['id', 'event_type'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['event_type', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.event_type,
    }));
  }
};
